leetcode: 3无重复字符的最长子串。滑动窗口,c语言

给定一个字符串 s ,请你找出其中不含有重复字符的 最长子串的长度。

示例 1:

复制代码
输入: s = "abcabcbb"
输出: 3 
解释: 因为无重复字符的最长子串是 "abc",所以其长度为 3。

示例 2:

复制代码
输入: s = "bbbbb"
输出: 1
解释: 因为无重复字符的最长子串是 "b",所以其长度为 1。

示例 3:

复制代码
输入: s = "pwwkew"
输出: 3
解释: 因为无重复字符的最长子串是 "wke",所以其长度为 3。
     请注意,你的答案必须是 子串 的长度,"pwke" 是一个子序列,不是子串。

提示:

  • 0 <= s.length <= 5 * 104
  • s 由英文字母、数字、符号和空格组成

思路:双指针,右指针每前进一次,就从左指针开始检查一次,看从左指针开始到右指针前一个数(左闭右开区间)有没有和右指针相等的。如果没有,这就是一个无重复字符的子串,如果有就让左指针跳到这个字符的下一个位置,因为这个字符和右指针所在字符重复了。

检查结束之后,记录下长度。

时间复杂度O(n);

空间复杂度O(1);

cpp 复制代码
int lengthOfLongestSubstring(char* s) {
    if(!*s)//数组长度为0时直接返回0;
    {
        return 0;
    }
    int ans=1;//默认为1,如果数组长度不为0,那么最小为1。有更长的会覆盖1
    int left=0;//窗口左边界
    int right=1;//窗口右边界
    while(s[right])
    {int i=left;//检查是否重复的变量
        for(;i<right;i++)//检查是否重复,右边界走一次就检查一次
        {
            if(s[i]==s[right])
            {
                left=i+1;//跳到该重复字符的下一个位置,因为s[i]==s[right]
                break;//重复就跳出循环
            }
        }   
     if(i==right)//完整的走完了循环才比较长度,删去这层if也行。
        {
            if(right-left+1>ans)//+1是因为,比如1-0=1,但是0------1是有两个元素的,即s[0]和s[1]
            {
                ans=right-left+1;
            }
        }
        right++;//右边界继续往前走
    }
    return ans;
}
相关推荐
wuminyu14 小时前
JVM规范学习总结:解释器与JIT编译器如何处理JVM字节码
java·linux·c语言·jvm·c++
圣保罗的大教堂18 小时前
leetcode 453. 最小操作次数使数组元素相等 中等
leetcode
水饺编程19 小时前
第2章:Linux 基础,解压缩【.tar.bz2】压缩包文件
linux·c语言·汇编
Zwawa20 小时前
串口命令如何从字符串长成协议:帧头、长度、校验和与状态机
c语言·单片机·嵌入式
Tisfy1 天前
LeetCode 0453.最小操作次数使数组元素相等:两次遍历(反向思维)
算法·leetcode·题解·遍历·反向思维
君万1 天前
【LeetCode每日一题】回溯:46. 全排列 78. 子集 39. 组合总和
算法·leetcode·go
Tisfy1 天前
LeetCode 3665.统计镜子反射路径数目:三个动态规划数组
leetcode·动态规划·代理模式·题解
海绵宝宝转agent1 天前
LeetCode100 二叉树个人题解
算法·leetcode·深度优先
文丑颜不良啊1 天前
LeetCode1581~1600题目解析
java·leetcode
文丑颜不良啊1 天前
LeetCode1541~1560题目解析
java·leetcode